ALTER TABLE `rv_clients`  ADD `shop_country` INT NOT NULL;
ALTER TABLE `rv_banners`  ADD `is_feed` INT NOT NULL;

CREATE TABLE `djax_all_network_feed` (
  `id` int(11) NOT NULL,
  `networkid` int(11) NOT NULL,
  `agencyid` int(11) NOT NULL,
  `clientid` int(11) NOT NULL,
  `campaignid` int(11) NOT NULL,
  `bannerid` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `djax_feed_ad_bkt_stats` (
  `response_id` int(11) NOT NULL,
  `date_time` datetime NOT NULL,
  `requests` bigint(20) NOT NULL,
  `ad_id` mediumint(9) NOT NULL,
  `zone_id` mediumint(9) NOT NULL,
  `feed_network_id` mediumint(9) NOT NULL,
  `keyword` varchar(100) NOT NULL,
  `ip` varchar(20) NOT NULL,
  `country` varchar(20) NOT NULL,
  `state` varchar(20) NOT NULL,
  `city` varchar(20) NOT NULL,
  `lattitude` varchar(20) NOT NULL,
  `longitude` varchar(20) NOT NULL,
  `user_agent` varchar(100) NOT NULL,
  `impressions` mediumint(9) NOT NULL,
  `clicks` mediumint(9) NOT NULL,
  `conversions` mediumint(9) NOT NULL,
  `revenue` decimal(10,6) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `djax_feed_ad_request` (
  `request_id` int(11) NOT NULL,
  `date_time` datetime NOT NULL,
  `ad_id` int(10) NOT NULL,
  `zone_id` mediumint(9) NOT NULL,
  `feed_network_id` mediumint(9) NOT NULL,
  `keyword` varchar(50) NOT NULL,
  `ip` varchar(20) NOT NULL,
  `country` varchar(20) NOT NULL,
  `state` varchar(20) NOT NULL,
  `city` varchar(20) NOT NULL,
  `lattitude` varchar(20) NOT NULL,
  `longitude` varchar(20) NOT NULL,
  `user_agent` varchar(100) NOT NULL,
  `bid` tinyint(2) NOT NULL,
  `bid_status` mediumint(9) NOT NULL,
  `is_delivered` tinyint(2) NOT NULL COMMENT 'to check feed ads delivered or not'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `djax_feed_configuration` (
  `id` int(11) NOT NULL,
  `network_max_req_day` mediumint(9) NOT NULL,
  `network_max_click_day` mediumint(9) NOT NULL,
  `network_max_click_ad` mediumint(9) NOT NULL,
  `network_max_click_keyword` varchar(50) NOT NULL,
  `network_max_click_ip` mediumint(9) NOT NULL,
  `network_min_ctr` float(10,2) NOT NULL,
  `network_max_ctr` float(10,2) NOT NULL,
  `network_max_results` mediumint(9) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `djax_feed_keyword` (
  `id` mediumint(100) NOT NULL,
  `banner_id` mediumint(100) NOT NULL DEFAULT '0',
  `keyword` int(30) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



CREATE TABLE `djax_feed_keywordlist` (
  `keyword_id` int(20) NOT NULL,
  `keyword` varchar(255) NOT NULL DEFAULT ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `djax_feed_network` (
  `feed_network_id` int(11) NOT NULL,
  `feed_network_agency_id` int(9) NOT NULL,
  `feed_network_name` varchar(100) NOT NULL,
  `publisher_id` varchar(100) NOT NULL DEFAULT 'Null',
  `source_id` int(9) NOT NULL,
  `auth_key` varchar(100) NOT NULL,
  `feed_network_ads_url` varchar(500) NOT NULL,
  `feed_network_report_url` varchar(500) NOT NULL,
  `feed_network_ads_base_url` varchar(500) NOT NULL,
  `feed_network_report_base_url` varchar(500) NOT NULL,
  `date_added` datetime NOT NULL,
  `status` tinyint(2) NOT NULL COMMENT '0=unblock,1=block',
  `is_valid` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'check weather two steps have been completed',
  `is_deleted` tinyint(2) NOT NULL,
  `is_white_label` tinyint(2) NOT NULL DEFAULT '1' COMMENT '0=no,1=yes',
  `clientid` bigint(20) NOT NULL,
  `campaignid` bigint(20) NOT NULL,
  `bannerid` text NOT NULL,
  `shop_country_id` int(11) NOT NULL,
  `shop_category_id` int(11) NOT NULL,
  `map_publisherid` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `djax_feed_networks_client_stats` (
  `id` int(11) NOT NULL,
  `date_time` datetime NOT NULL,
  `network_id` mediumint(9) NOT NULL,
  `ad_id` int(11) NOT NULL,
  `zone_id` int(11) NOT NULL,
  `user_agent` varchar(100) CHARACTER SET utf8 NOT NULL,
  `requests` mediumint(9) NOT NULL,
  `impressions` mediumint(9) NOT NULL,
  `clicks` mediumint(9) NOT NULL,
  `conversions` mediumint(9) NOT NULL,
  `revenue` decimal(10,6) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `djax_feed_networks_geo_stats` (
  `id` int(11) NOT NULL,
  `date_time` datetime NOT NULL,
  `network_id` int(11) NOT NULL,
  `ad_id` int(11) NOT NULL,
  `zone_id` int(11) NOT NULL,
  `ip` varchar(20) NOT NULL,
  `country` varchar(20) NOT NULL,
  `state` varchar(20) NOT NULL,
  `city` varchar(20) NOT NULL,
  `lattitude` varchar(20) NOT NULL,
  `longitude` varchar(20) NOT NULL,
  `requests` mediumint(9) NOT NULL,
  `impressions` mediumint(9) NOT NULL,
  `clicks` mediumint(9) NOT NULL,
  `conversions` mediumint(9) NOT NULL,
  `revenue` decimal(10,6) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


CREATE TABLE `djax_feed_networks_keyword_stats` (
  `id` int(11) NOT NULL,
  `date_time` datetime NOT NULL,
  `network_id` mediumint(9) NOT NULL,
  `ad_id` int(11) NOT NULL,
  `zone_id` int(11) NOT NULL,
  `keywords` varchar(100) CHARACTER SET utf8 NOT NULL,
  `requests` mediumint(9) NOT NULL,
  `impressions` mediumint(9) NOT NULL,
  `clicks` mediumint(9) NOT NULL,
  `conversions` mediumint(9) NOT NULL,
  `revenue` decimal(10,6) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `djax_feed_networks_stats` (
  `id` int(11) NOT NULL,
  `date_time` datetime NOT NULL,
  `network_id` mediumint(9) NOT NULL,
  `ad_id` int(11) NOT NULL,
  `zone_id` int(11) NOT NULL,
  `requests` mediumint(9) NOT NULL,
  `impressions` mediumint(9) NOT NULL,
  `clicks` mediumint(9) NOT NULL,
  `conversions` mediumint(9) NOT NULL,
  `unique_impressions` mediumint(9) NOT NULL,
  `unique_clicks` mediumint(9) NOT NULL,
  `revenue` decimal(10,6) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


CREATE TABLE `djax_feed_network_advertiser_assoc` (
  `id` int(9) NOT NULL,
  `feed_network_id` int(9) NOT NULL,
  `feed_network_adv_acc_id` int(9) NOT NULL,
  `feed_network_cpc_camp_id` int(11) NOT NULL,
  `feed_network_cpa_camp_id` int(11) NOT NULL,
  `feed_network_cpm_camp_id` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `djax_feed_network_limitations` (
  `id` int(9) NOT NULL,
  `feed_network_id` int(9) NOT NULL,
  `network_max_req_day` int(9) NOT NULL,
  `network_max_click_day` int(9) NOT NULL,
  `network_max_click_ad` int(9) NOT NULL,
  `network_max_click_keyword` int(9) NOT NULL,
  `network_max_click_ip` int(9) NOT NULL,
  `network_min_ctr` int(9) NOT NULL,
  `network_max_ctr` int(11) NOT NULL,
  `network_max_results` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


CREATE TABLE `djax_feed_network_parameters` (
  `id` int(10) NOT NULL,
  `feed_network_id` int(10) NOT NULL,
  `publisher_id` varchar(100) NOT NULL DEFAULT 'Null',
  `source_id` varchar(100) NOT NULL DEFAULT 'Null',
  `auth_key` varchar(100) NOT NULL DEFAULT 'Null',
  `ip_address` varchar(100) NOT NULL DEFAULT 'Null',
  `keyword` varchar(100) NOT NULL DEFAULT 'Null',
  `user_agent` varchar(100) NOT NULL DEFAULT 'Null',
  `result_count` varchar(100) NOT NULL DEFAULT 'Null',
  `serveurl` varchar(100) NOT NULL DEFAULT 'Null',
  `via` varchar(100) NOT NULL DEFAULT 'Null',
  `xfwd` varchar(100) NOT NULL DEFAULT 'Null',
  `xtype` varchar(100) NOT NULL DEFAULT 'Null',
  `xformat` varchar(100) NOT NULL DEFAULT 'Null',
  `ref_url` varchar(255) NOT NULL DEFAULT 'Null',
  `subid` varchar(250) NOT NULL DEFAULT 'Null'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `djax_feed_network_publishers_assoc` (
  `id` int(11) NOT NULL,
  `publisher_affilate_id` int(9) NOT NULL,
  `feed_network_id` int(9) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `djax_feed_network_report_parameters` (
  `id` int(10) NOT NULL,
  `feed_network_id` int(10) NOT NULL,
  `publisher_id` varchar(100) NOT NULL DEFAULT 'Null',
  `source_id` varchar(100) NOT NULL DEFAULT 'Null',
  `auth_key` varchar(100) NOT NULL DEFAULT 'Null',
  `ip_address` varchar(100) NOT NULL DEFAULT 'Null',
  `keyword` varchar(100) NOT NULL DEFAULT 'Null',
  `user_agent` varchar(100) NOT NULL DEFAULT 'Null',
  `result_count` varchar(100) NOT NULL DEFAULT 'Null',
  `serveurl` varchar(100) NOT NULL DEFAULT 'Null',
  `via` varchar(100) NOT NULL DEFAULT 'Null',
  `xfwd` varchar(100) NOT NULL DEFAULT 'Null',
  `xtype` varchar(100) NOT NULL DEFAULT 'Null',
  `xformat` varchar(100) NOT NULL DEFAULT 'Null'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


CREATE TABLE `djax_xml_feed_api_request` (
  `request_id` int(11) NOT NULL,
  `date_time` datetime NOT NULL,
  `ad_id` int(10) NOT NULL,
  `zone_id` mediumint(9) NOT NULL,
  `feed_network_id` mediumint(9) NOT NULL,
  `keyword` varchar(50) NOT NULL,
  `ip` varchar(20) NOT NULL,
  `country` varchar(20) NOT NULL,
  `state` varchar(20) NOT NULL,
  `city` varchar(20) NOT NULL,
  `lattitude` varchar(20) NOT NULL,
  `longitude` varchar(20) NOT NULL,
  `user_agent` varchar(100) NOT NULL,
  `bid` tinyint(2) NOT NULL,
  `bid_status` mediumint(9) NOT NULL,
  `is_delivered` tinyint(2) NOT NULL COMMENT 'to check feed ads delivered or not',
  `publisher_id` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


CREATE TABLE `djax_xml_feed_stats` (
  `id` int(11) NOT NULL,
  `date` datetime NOT NULL,
  `request_id` int(11) NOT NULL,
  `publisherid` int(11) NOT NULL,
  `ad_id` int(11) NOT NULL,
  `impressions` int(11) NOT NULL,
  `clicks` int(11) NOT NULL,
  `conversions` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


CREATE TABLE `rv_data_bkt_xmlfeednetwork_c` (
  `interval_start` datetime NOT NULL,
  `creative_id` mediumint(9) NOT NULL,
  `zone_id` mediumint(9) NOT NULL,
  `revenue` decimal(10,4) NOT NULL,
  `count` int(11) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `rv_data_bkt_xmlfeednetwork_m` (
  `interval_start` datetime NOT NULL,
  `creative_id` mediumint(9) NOT NULL,
  `zone_id` mediumint(9) NOT NULL,
  `revenue` decimal(10,4) NOT NULL,
  `count` int(11) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `rv_stats_xmlfeednetwork` (
  `stats_xmlfeednetwork_id` bigint(20) NOT NULL,
  `date_time` datetime NOT NULL,
  `creative_id` int(10) UNSIGNED NOT NULL,
  `zone_id` int(10) UNSIGNED NOT NULL,
  `impressions` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `clicks` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `revenue` decimal(10,4) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `xml_shop_country` (
  `id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `full_name` varchar(250) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE `djax_all_network_feed` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_ad_bkt_stats` ADD PRIMARY KEY (`response_id`);
ALTER TABLE `djax_feed_ad_request` ADD PRIMARY KEY (`request_id`);
ALTER TABLE `djax_feed_configuration` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_keyword` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_keywordlist` ADD PRIMARY KEY (`keyword_id`), ADD UNIQUE KEY `keyword` (`keyword`);
ALTER TABLE `djax_feed_network` ADD PRIMARY KEY (`feed_network_id`);
ALTER TABLE `djax_feed_networks_client_stats` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_networks_geo_stats` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_networks_keyword_stats` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_networks_stats` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_network_advertiser_assoc` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_network_limitations` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_network_parameters` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_network_publishers_assoc` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_feed_network_report_parameters` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_xml_feed_api_request` ADD PRIMARY KEY (`request_id`);
ALTER TABLE `djax_xml_feed_stats` ADD PRIMARY KEY (`id`);
ALTER TABLE `rv_data_bkt_xmlfeednetwork_c` ADD PRIMARY KEY (`interval_start`,`creative_id`,`zone_id`);
ALTER TABLE `rv_data_bkt_xmlfeednetwork_m` ADD PRIMARY KEY (`interval_start`,`creative_id`,`zone_id`);
ALTER TABLE `rv_stats_xmlfeednetwork` ADD PRIMARY KEY (`stats_xmlfeednetwork_id`), ADD KEY `rv_stats_xmlfeednetwork_dt` (`date_time`), ADD KEY `rv_stats_xmlfeednetwork_cid_dt` (`creative_id`,`date_time`), ADD KEY `rv_stats_xmlfeednetwork_zid_dt` (`zone_id`,`date_time`);
ALTER TABLE `xml_shop_country` ADD PRIMARY KEY (`id`);
ALTER TABLE `djax_all_network_feed` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_ad_bkt_stats` MODIFY `response_id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_ad_request` MODIFY `request_id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_configuration` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_keyword` MODIFY `id` mediumint(100) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_keywordlist` MODIFY `keyword_id` int(20) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_network` MODIFY `feed_network_id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_networks_client_stats` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_networks_geo_stats` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_networks_keyword_stats` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_networks_stats` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_network_advertiser_assoc` MODIFY `id` int(9) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_network_limitations` MODIFY `id` int(9) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_network_parameters` MODIFY `id` int(10) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_network_publishers_assoc` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_feed_network_report_parameters` MODIFY `id` int(10) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_xml_feed_api_request` MODIFY `request_id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `djax_xml_feed_stats` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `rv_stats_xmlfeednetwork` MODIFY `stats_xmlfeednetwork_id` bigint(20) NOT NULL AUTO_INCREMENT;
ALTER TABLE `xml_shop_country` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
COMMIT;
