<?php

/*
+---------------------------------------------------------------------------+
| Revive Adserver                                                           |
| http://www.revive-adserver.com                                            |
|                                                                           |
| Copyright: See the COPYRIGHT.txt file.                                    |
| License: GPLv2 or later, see the LICENSE.txt file.                        |
+---------------------------------------------------------------------------+
*/

/**
 * @package    OpenXPlugin
 * @subpackage InvocationTags
 *
 */

require_once LIB_PATH . '/Extension/invocationTags/InvocationTags.php';
require_once MAX_PATH . '/lib/max/Plugin/Translation.php';

/**
 *
 * Invocation tag plugin.
 *
 */
class Plugins_InvocationTags_OxInvocationTags_shopfeedjs extends Plugins_InvocationTags
{

    /**
     * Return name of plugin
     *
     * @return string
     */
    function getName()
    {
        return $this->translate("Shopfeed Tag");
    }

    /**
     * Return the English name of the plugin. Used when
     * generating translation keys based on the plugin
     * name.
     *
     * @return string An English string describing the class.
     */
    function getNameEN()
    {
        return 'Shopfeed Tag';
    }

    /**
     * Check if plugin is allowed
     *
     * @return boolean  True - allowed, false - not allowed
     */
    function isAllowed($extra = null)
    {
        return true;
    }

    function getOrder()
    {
        parent::getOrder();
        return 23;
    }

    /**
     * Return list of options
     *
     * @return array    Group of options
     */
    function getOptionsList()
    {
        if (is_array($this->defaultOptions)) {
            if (in_array('cacheBuster', $this->defaultOptions)) {
                unset($this->defaultOptions['cacheBuster']);
            }
        }
        $options = array (
            'spacer'      => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            'what'          => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            //'clientid'      => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            'campaignid'    => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            //~ 'block'         => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            //~ 'target'        => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            //~ 'source'        => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            //~ 'withtext'      => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            //~ 'blockcampaign' => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            //~ 'charset'       => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            'row'     => 2,
            'column'     => 3
        );
       
        return $options;
    }
    function row()
    {
        $maxInvocation = &$this->maxInvocation;
		$maxInvocation->row = $_POST['row'] ? $_POST['row'] : 2; 
		
        $option = '';
        $option .= "<tr><td colspan='3' height='10' width='30'>&nbsp;</td></tr>";
        $option .= "<tr><td  width='30'>&nbsp;</td>";
        $option .= "<td width='200'>Row</td><td width='370'>";
        $option .= "<input class='flat' type='text' name='row' size='' value='".(isset($maxInvocation->row) ? $maxInvocation->row : $this->defaultValues['row'])."' style='width: 30px;padding: 2px 5px;' tabindex='".($maxInvocation->tabindex++)."'></td></tr>";
        $option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
        return $option;
    }



    function column()
    { 
        $maxInvocation = &$this->maxInvocation;
		$maxInvocation->column = $_POST['column'] ? $_POST['column'] : 3; 
        $option = '';
		$option .= "<tr><td colspan='3' height='5' width='30'>&nbsp;</td></tr>";
        $option .= "<tr><td  width='30'>&nbsp;</td>";
        $option .= "<td width='200'>Column</td><td width='370'>";
        $option .= "<input class='flat' type='text' name='column' size='' value='".(isset($maxInvocation->column) ? $maxInvocation->column : $this->defaultValues['column'])."' style='width: 30px;padding: 2px 5px;' tabindex='".($maxInvocation->tabindex++)."'></td></tr>";
        $option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
        return $option;
    }

    /**
     * Return invocation code for this plugin (codetype)
     *
     * @return string
     */
    function generateInvocationCode()
    {
        $aComments = array(
            'SSL Delivery Comment' => '',
            'Comment'              => $this->translate("
  * This noscript section of this tag only shows image banners. There
  * is no width or height in these banners, so if you want these tags to
  * allocate space for the ad before it shows, you will need to add this
  * information to the <img> tag.
  *
  * If you do not want to deal with the intricities of the noscript
  * section, delete the tag (from <noscript>... to </noscript>). On
  * average, the noscript tag is called from less than 1% of internet
  * users."),
            );
        parent::prepareCommonInvocationData($aComments);
        $row = "2";
			if (isset($_POST['row']) && !empty($_POST['row'])) {
				$row = $_POST['row'];
			}
			$column = "3";
			if (isset($_POST['column']) && !empty($_POST['column'])) {
				$column = $_POST['column'];
			}
			

        $conf = $GLOBALS['_MAX']['CONF'];
        $mi = &$this->maxInvocation;

        $buffer = $mi->buffer;

       if (isset($mi->withtext) && $mi->withtext != '0') {
            $mi->parameters['withtext'] = "withtext=1";
        }
        if (isset($mi->block) && $mi->block == '1') {
            $mi->parameters['block'] = "block=1";
        }
        if (isset($mi->blockcampaign) && $mi->blockcampaign == '1') {
            $mi->parameters['blockcampaign'] = "blockcampaign=1";
        }
        if (!empty($mi->campaignid)) {
            $mi->parameters['campaignid'] = "campaignid=".$mi->campaignid;
        }
        // The cachebuster for JS tags is auto-generated
        unset($mi->parameters['cb']);

        $way=$conf['webpath']['admin'].'/plugins/XmlFeedNetwork/delivery/shopfeed.php';
        $buffer .= "<script type='text/javascript'><!--//<![CDATA[\n";
        $buffer .= "   var m3_u = (location.protocol=='https:'?'https://$way':'http://$way');\n";
        $buffer .= "   var m3_r = Math.floor(Math.random()*99999999999);\n";
        $buffer .= "   if (!document.MAX_used) document.MAX_used = ',';\n";
        // Removed the non-XHTML compliant "language='JavaScript'
        $buffer .= "   document.write (\"<scr\"+\"ipt type='text/javascript' src='\"+m3_u);\n";
        if (count($mi->parameters) > 0) {
            $buffer .= "   document.write (\"?".implode ("&amp;", $mi->parameters)."\");\n";
        }
        
        $buffer .="   document.write ('&amp;cb=' + m3_r);\n";
        $buffer .="   document.write ('&amp;row={$row}');\n";
        $buffer.="   document.write ('&amp;column={$column}');\n";
       
        // Don't pass in exclude unless necessary
        $buffer .= "   if (document.MAX_used != ',') document.write (\"&amp;exclude=\" + document.MAX_used);\n";

        if (empty($mi->charset)) {
            $buffer .= "   document.write (document.charset ? '&amp;charset='+document.charset : (document.characterSet ? '&amp;charset='+document.characterSet : ''));\n";
        } else {
            $buffer .= "   document.write ('&amp;charset=" . $mi->charset . "');\n";
        }
        $buffer .= "   document.write (\"&amp;loc=\" + escape(window.location));\n";
        $buffer .= "   if (document.referrer) document.write (\"&amp;referer=\" + escape(document.referrer));\n";
        $buffer .= "   if (document.context) document.write (\"&context=\" + escape(document.context));\n";

        $buffer .= "   document.write (\"'><\\/scr\"+\"ipt>\");\n";
        $buffer .= "//]]>--></script>";

        if (isset($mi->extra['delivery']) && $mi->extra['delivery'] != phpAds_ZoneText) {
            $buffer .= "<noscript>{$mi->backupImage}</noscript>\n";
        }
        return $buffer;
    }

    function setInvocation(&$invocation) {
        $this->maxInvocation = &$invocation;
        $this->maxInvocation->canDetectCharset = true;
    }

}

?>
