<?php

require_once '../../../../init.php';
// Required files
require_once MAX_PATH . '/lib/OA/Admin/Option.php';
require_once MAX_PATH . '/lib/OA/Admin/Settings.php';
require_once MAX_PATH . '/lib/max/Plugin/Translation.php';
require_once MAX_PATH . '/lib/OX/Plugin/Component.php';
require_once MAX_PATH . '/www/admin/config.php';

if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql') {
    require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
} else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli') {
    require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
}
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];

// Security check
OA_Permission::enforceAccount(OA_ACCOUNT_ADMIN);
$oTranslation = new OX_Translation();
// Create a new option object for displaying the setting's page's HTML form
$oOptions = new OA_Admin_Option('account-settings-feedlist');
$prefSection = "xmlfeed Network Integration";
$setPref = $oOptions->getSettingsPreferences($prefSection);
$title = $setPref[$prefSection]['name'];
$oHeaderModel = new OA_Admin_UI_Model_PageHeaderModel("Xml Feed Network Integration");
phpAds_PageHeader('account-settings-feedlist', $oHeaderModel);
?>

<div style="float:right;"><a style="display: block;width: 132px;height: 10px;
    background: #DDDCDC;
    padding: 10px;
    text-align: center;
    border-radius: 5px;
    color:#0767a8;
    font-weight: bold;" href="account-settings-feeds.php">Add Xmlfeed Network</a></div>

<div style="clear:both;"></div>

<div class="tableWrapper">
    <div class="tableHeader">
        <ul class='tableActions'>
            <li class='inactive activeIfSelected'>
                <a id='enableSelection' href=""><img src="images/adxactive.png" width="15px" height="15px">&nbsp;UnBlock</a>
                <script type='text/javascript'>
                <!--
                $('#enableSelection').click(function(event) {
                    event.preventDefault();
                    if(!$(this).parents('li').hasClass('inactive')) {
                        var ids = [];
                        $(this).parents('.tableWrapper').find('.toggleSelection input:checked').each(function() {
                            ids.push(this.value);
                        });
                        window.location = 'oxm_feedaction.php?action=enable&netid=' + ids.join(',');
                    }
                });
                </script>
            </li>
            <li class='inactive activeIfSelected'>
                <a id='disableSelection' href=""><img src="images/adxdeactive.png" width="15px" height="15px">&nbsp;Block</a>
                <script type='text/javascript'>
                <!--
                $('#disableSelection').click(function(event) {
                    event.preventDefault();
                    if(!$(this).parents('li').hasClass('inactive')) {
                        var ids = [];
                        $(this).parents('.tableWrapper').find('.toggleSelection input:checked').each(function() {
							console.log(this.value);
                            ids.push(this.value);
                        });
                        console.log(ids);
                        //return false;
                        window.location = 'oxm_feedaction.php?action=disable&netid=' + ids.join(',');
                    }
                });
                </script>
            </li>
        </ul>
        <div class="clear"></div>
        <div class="corner left"></div>
        <div class="corner right"></div>
    </div>
    <table cellspacing="0" summary="">
        <thead>
            <tr>
                <th class='first toggleAll'>
                    <input type='checkbox' /> </th>
                <th> <a href="#">Feed Network name</a> </th>
                <th> <a href="#">Feed Network added on</a> </th>
                <th> <a href="#">Feed Network Limitaions</a> </th>
                <th> <a href="#">Status</a> </th>
                <th> <a href="#">Action</a> </th>
                <th class=""> </th>
            </tr>
        </thead>
        <tbody>
<?php

$tempQuery = OA_Dal_Delivery_query("Select * FROM djax_feed_network where is_deleted = 0 AND feed_network_id!=1 ORDER BY feed_network_id ASC");
$i = 1;
if (OA_Dal_Delivery_numRows($tempQuery) > 0) {
    while ($row = OA_Dal_Delivery_fetchAssoc($tempQuery)) {
        if ($i == 1) {
            $_class = "odd hilite";
        } elseif ($i % 2 == 0) {
            $_class = "even";
        } else {
            $_class = "odd";
        }
?>

	<tr class="<?php echo $_class; ?>">
		<td class='toggleSelection'>
			<input type='checkbox' value="<?php print_r($row['feed_network_id']); ?>" />
		</td>

		<td>
			<?php print_r($row['feed_network_name']); ?>
		</td>

		<?php $credate = date('jS F, Y', strtotime($row['date_added'])); ?>

		<td>
			<?php print_r($credate); ?>
		</td>
		
		<td>
			<a href="oxm_feedlimit.php?netid=<?php echo $row['feed_network_id'];?>" class='inlineIcon iconAdx'>Set limitations</a>
		</td>

		<td>
			<?php if ($row['status'] == '0') { ?>
			<a href="#" class='inlineIcon iconAdxactive'><img src="images/adxactive.png" width="15px" height="15px"></a>
			<?php } else { ?>
			<a href="#" class='inlineIcon iconAdxdeactive'><img src="images/adxdeactive.png" width="15px" height="15px"></a>
			<?php } ?>
		</td>

		<td>
			<a href="oxm_feededit.php?netid=<?php echo $row['feed_network_id']; ?>&action=edit">Edit/ </a>
			<a href="oxm_feeddelete.php?netid=<?php print_r($row['feed_network_id']); ?>&action=delete">Delete/ </a>
			<?php if ($row['status'] == '0') { ?>
			<a href="oxm_feedaction.php?netid=<?php print_r($row['feed_network_id']); ?>&action=disable">Block</a>
			<?php } else { ?>
			<a href="oxm_feedaction.php?netid=<?php print_r($row['feed_network_id']); ?>&action=enable">UnBlock</a>
		   <?php } ?>
		</td>

		<td class="alignRight verticalActions">
			<ul class="rowActions">
				<li></li>
			</ul>
		</td>

	</tr>
<?php
        $i++;
    }
} else {
?>

<tr class='odd'>
    <td colspan='6'>&nbsp;</td>
</tr>
<tr class='even'>
    <td colspan='4' class="hasPanel">
        <div class='tableMessage'>
            <div class='panel'> CURRENTLY THERE ARE NO ADEXCHANGE AVAILABLE TO LIST
                <div class='corner top-left'></div>
                <div class='corner top-right'></div>
                <div class='corner bottom-left'></div>
                <div class='corner bottom-right'></div>
            </div>
        </div>
    </td>
    <td>&nbsp;</td>
</tr>
</tr>
<tr class='odd'>
    <td colspan='4'>&nbsp;</td>
    <td colspan='4'>&nbsp;</td>
</tr>

<?php
}
?>

</tbody>
</table>
</div>

<script type="text/javascript">
GB_myShow1 = function(caption, url, /* optional */ height, width, callback_fn) {
    var options = {
        caption: caption,
        height: height || 350,
        width: width || 605,
        fullscreen: false,
        show_loading: false,
        callback_fn: callback_fn
    }
    var win = new GB_Window(options);
    return win.show(url);
}
</script>

<?php

phpAds_PageFooter();

?>
