<?php
// Require the initialisation file
require_once '../../../../init.php';
// Required files
require_once MAX_PATH.'/www/admin/config.php';
require_once LIB_PATH.'/Plugin/PluginManager.php';
require_once LIB_PATH.'/Plugin/ComponentGroupManager.php';
if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/pgsql.php';
}
else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/mysqli.php';
}
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
// Security check
OA_Permission::enforceAccount(OA_ACCOUNT_ADMIN);
$oPluginManager = new OX_PluginManager();
$oComponentGroupManager = new OX_Plugin_ComponentGroupManager();
phpAds_PageHeader('feed-keyword-report', $oHeaderModel);

$_network = !empty($_POST['sel']) ? $_post['sel'] : '';
$_period = !empty($_POST['period_preset']) ? $_POST['period_preset'] : '';

if ($_POST['period_preset'] != '')
{
    if ($_POST['period_preset'] == 'today')
    {
        $start = date('Y-m-d');
        $end = date('Y-m-d');
    }
    else if ($_POST['period_preset'] == 'yesterday')
    {
        $start = date('Y-m-d', strtotime('Yesterday'));
        $end = date('Y-m-d', strtotime('Yesterday'));
    }
    else if ($_POST['period_preset'] == 'this_week')
    {
        $start = date('Y-m-d', strtotime('this week Monday'));
        $end = date('Y-m-d');
    }
    else if ($_POST['period_preset'] == 'last_week')
    {
        $previous_week = strtotime("-1 week +1 day");
        $start_week = strtotime("last monday midnight", $previous_week);
        $end_week = strtotime("next sunday", $start_week);
        $start = date("Y-m-d", $start_week);
        $end = date("Y-m-d", $end_week);
    }
    else if ($_POST['period_preset'] == 'last_7_days')
    {
        $start = date('Y-m-d', strtotime('Today - 7 Day'));
        $end = date('Y-m-d', strtotime('Today - 1 Day'));
    }
    else if ($_POST['period_preset'] == 'this_month')
    {
        $start = date('Y-m-d', mktime(0, 0, 0, date('m') , 1, date('Y')));
        $end = date('Y-m-d');
    }
    else if ($_POST['period_preset'] == 'last_month')
    {
        $start = date('Y-m-d', mktime(0, 0, 0, (date('m') - 1) , 1, date('Y')));
        $end = date('Y-m-d', mktime(0, 0, 0, date('m') , 0, date('Y')));
    }
    else if ($_POST['period_preset'] == 'all_stats')
    {
        $start = '0000-00-00';
        $end = date('Y-m-d');
    }
    else if ($_POST['period_preset'] == 'specific')
    {
        $start = $_POST['period_start'];
        $end = $_POST['period_end'];
    }
}
else
{
    $start = date('Y-m-d');
    $end = date('Y-m-d');
}
$network_id = $_POST['sel'];
$and = "";
if ($network_id != 'all' && !empty($network_id))
{
    $and = "AND fn.feed_network_id =".$network_id."";
}
$exdat = OA_Dal_Delivery_query("SELECT
oxa.`website` as website,
SUM(a.`requests`) as WINREQ,
SUM(a.`impressions`) as IMP,
SUM(a.`clicks`) as CLK,
SUM(a.`conversions`) as CON,
SUM(a.`revenue`) as REV,
fn.feed_network_id,
fn.feed_network_name,
a.keywords,
ROUND(IFNULL(SUM(a.`clicks`),0)/IFNULL(SUM(a.`impressions`),0)*100,2) AS CTR
FROM
djax_feed_networks_keyword_stats as a
JOIN {$table_prefix}zones as oxz ON oxz.zoneid=a.zone_id
JOIN djax_feed_network as fn ON fn.feed_network_id=a.network_id
JOIN {$table_prefix}affiliates as oxa ON oxa.affiliateid=oxz.affiliateid
WHERE
a.network_id !=0 AND date(a.date_time) BETWEEN '".$start."' AND '".$end."' ".$and." GROUP BY fn.feed_network_id") or die("Query error");
?>

<form method='post'>
<b>Feed Network Name :</b>
<select name='sel' id='sel' onchange="periodFormChange(1)">
<option value="all"  <?php if($_POST['sel'] == 'all') { ?> selected='selected' <?php } ?>>All Networks</option>

<?php

$list = OA_Dal_Delivery_query("select * from djax_feed_network where feed_network_id !=1");


while($listing = OA_Dal_Delivery_fetchAssoc($list))
{
?>

<!--Feed network list-->
<option value = "<?php echo $listing['feed_network_id'];?>" <?php if($listing['feed_network_id'] == $_POST['sel']) { ?> selected='selected' <?php } ?>><?php echo $listing['feed_network_name'];?></option>
<?php
}?>
</select>
<!--Feed network list-->

<!--Time duration -->
        <select name='period_preset' id='period_preset' onchange='periodFormChange(1)' tabindex='1'>
            <option value='today' selected='selected'>Today</option>
            <option value='yesterday' <?php if($_period == "yesterday") : ?> selected="selected" <?php endif; ?> >Yesterday</option>
            <option value='this_week' <?php if($_period == "this_week") : ?> selected="selected" <?php endif; ?> >This week</option>
            <option value='last_week' <?php if($_period == "last_week") : ?> selected="selected" <?php endif; ?> > Last week</option>
            <option value='last_7_days' <?php if($_period == "last_7_days") : ?> selected="selected" <?php endif; ?> >Last 7 days</option>
            <option value='this_month' <?php if($_period == "this_month") : ?> selected="selected" <?php endif; ?> >This month</option>
            <option value='last_month' <?php if($_period == "last_month") : ?> selected="selected" <?php endif; ?> >Last month</option>
            <option value='all_stats' <?php if($_period == "all_stats") : ?> selected="selected" <?php endif; ?> >All statistics</option>
            <option value='specific' <?php if($_period == "specific") : ?> selected="selected" <?php endif; ?> >Specific dates</option>
        </select>

		<label for='period_start' style='margin-left: 1em'></label>
		<input class="date" name="period_start" id="period_start" type="text" value="<?php  if(!empty($start)){ echo $start;}else{ echo date('Y-m-d');}?>" tabindex="2"/>
		<input type='image' src='images/icon-calendar-d.gif' id='period_start_button' align='absmiddle' border='0' tabindex='3' />
		<label for='period_end' style='margin-left: 1em'> </label>

		<input class="date" name="period_end" id="period_end" type="text" value="<?php if(!empty($end)){ echo $end;}else{ echo date('Y-m-d');} ?>" tabindex="4" /> 
		<input type='image' src='images/icon-calendar-d.gif' id='period_end_button' align='absmiddle' border='0' tabindex='3' />
		<a href='' onclick='return periodFormSubmit()'>
		<img src='images/go_blue.gif' border='0' tabindex='6' /></a>
</form>


<div style='height:50px;'></div>
<?php
if(OA_Dal_Delivery_numRows($exdat)>0)
{
?>
<table   border='2px' align='center' style = 'border-bottom-width:4px;'><tr> <th width="150px">Feed Network Name</th><th width="150px">Publisher</th><th width='150px'>Impressions</th><th width='150px'>Clicks</th><th width='150px'>Revenue</th><th width='150px'>CTR</th><th width='150px'>Keywords</th></tr>
<?php

	while($valdet=OA_Dal_Delivery_fetchAssoc($exdat))
	{
		echo '<tr>';
		echo '<td>'.$valdet['feed_network_name'].'</td>';
		echo '<td>'.$valdet['website'].'</td>';	
		echo '<td>'.$valdet['IMP'].'</td>';
		echo '<td>'.$valdet['CLK'].'</td>';
		echo '<td>'.$valdet['CTR'].'</td>';	    
	    echo '<td>'.$valdet['REV'].'</td>';
	    echo '<td>'.$valdet['keywords'].'</td>';
		echo '</tr>';	
	}
	echo '</table>';
}
else
{
echo '<table width="100%"><tr><td style="text-align:center;color:red;font-weight:bold;font-size:15px;">Currently No Statistics For This Period</td></tr></table>';
}
?>

<script type='text/javascript'>
<!--
Calendar.setup({
	inputField: 'period_start',
	ifFormat: '%Y-%m-%d',
	button: 'period_start_button',
	align: 'Bl',
	weekNumbers: false,
	firstDay: 1,
	electric: false
});
Calendar.setup({
	inputField: 'period_end',
	ifFormat: '%Y-%m-%d',
	button: 'period_end_button',
	align: 'Bl',
	weekNumbers: false,
	firstDay: 1,
	electric: false
});
//-->
function periodFormChange(bAutoSubmit) {
	var o = document.getElementById('period_preset');
	var periodSelectName = o.options[o.selectedIndex].value;
	/* DAC start */
	var n = document.getElementById('sel');
	var networkSelectName = n.options[n.selectedIndex].value;
	/*DAC end */
	var specific = periodSelectName == 'specific';
	var periodTabIndex = 2;
	document.getElementById('period_start').readOnly = !specific;
	document.getElementById('period_start_button').disabled = !specific;
	document.getElementById('period_end').readOnly = !specific;
	document.getElementById('period_end_button').disabled = !specific;
	if(!specific) {
		document.getElementById('period_start').style.backgroundColor = '#CCCCCC';
		document.getElementById('period_end').style.backgroundColor = '#CCCCCC';
		document.getElementById('period_start').tabIndex = null;
		document.getElementById('period_start_button').tabIndex = null;
		document.getElementById('period_end').tabIndex = null;
		document.getElementById('period_end_button').tabIndex = null;
		document.getElementById('period_start_button').src = 'images/icon-calendar-d.gif';
		document.getElementById('period_end_button').src = 'images/icon-calendar-d.gif';
	} else {
		document.getElementById('period_start').style.backgroundColor = '#FFFFFF';
		document.getElementById('period_end').style.backgroundColor = '#FFFFFF';
		document.getElementById('period_start').tabIndex = periodTabIndex;
		document.getElementById('period_start_button').tabIndex = periodTabIndex + 1;
		document.getElementById('period_end').tabIndex = periodTabIndex + 2;
		document.getElementById('period_end_button').tabIndex = periodTabIndex + 3;
		document.getElementById('period_start_button').src = 'images/icon-calendar.gif';
		document.getElementById('period_end_button').src = 'images/icon-calendar.gif';
	}
	document.getElementById('period_start_button').readOnly = !specific;
	document.getElementById('period_end_button').readOnly = !specific;
	document.getElementById('period_start_button').style.cursor = specific ? 'auto' : 'default';
	document.getElementById('period_end_button').style.cursor = specific ? 'auto' : 'default';
	if(!specific && bAutoSubmit) {
		o.form.submit();
	}
}
periodFormChange(0);

function periodFormSubmit() {
	var form = document.getElementById('period_preset').form;
	var n = document.getElementById('sel').form;
	if(checkDates(form) && n) {
		form.submit();
	}
	return false;
}

function checkDates(form) {
	var startField = form.period_start;
	var endField = form.period_end;
	if(!startField.disabled && startField.value != '') {
		var start = Date.parseDate(startField.value, '%Y-%m-%d');
	}
	if(!startField.disabled && endField.value != '') {
		var end = Date.parseDate(endField.value, '%Y-%m-%d');
	}
	if((start != undefined && end != undefined) && (start.getTime() > end.getTime())) {
		alert('\'From\' date must be earlier then \'To\' date');
		return false;
	}
	return true;
}
</script>
<style type='text/css'>
th {
	background-color: #10a64c;
	border-color: #DDDDDD;
	color: white;
	font-weight: bold;
	text-align: center;
	font-size: 11px;
}

td {
	border-color: #DDDDDD;
	font-weight: bold;
	font-size: 10px;
	text-align: center;
	padding: 6px;
}

table {
	border: groove;
	border-color: #DDDDDD;
	border-bottom-width: 20px;
}
</style>

<?php

phpAds_PageFooter();

?>
