<?php

require_once '../../../../init.php';
if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql')
{
    require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
}
else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli')
{
    require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
}

set_time_limit(0);

$oStartDate = date('Y-m-d H:00:00', strtotime('-1 hour'));
$oEndDate   = date('Y-m-d H:59:59', strtotime('-1 hour'));

_djax_feed_network_update($oStartDate, $oEndDate, $toTable);

function _djax_feed_network_update($oStartDate, $oEndDate, $toTable)
{
	/*	Network Statistics	*/
	djax_feed_netword_stats($oStartDate, $oEndDate, $toTable);
	/*  GEO Statistics		*/
	djax_feed_geo_stats($oStartDate, $oEndDate, $toTable);
	/* Client Statistics	*/
	djax_feed_client_stats($oStartDate, $oEndDate, $toTable);
	/*Keyword Statistics */
	djax_feed_keyword_stats($oStartDate, $oEndDate, $toTable);
    /*Delete bucket data		*/
    $djax_delete_bkt_data = "delete from djax_feed_ad_bkt_stats WHERE date_time >= '".$oStartDate."' AND date_time <= '".$oEndDate."'";
    OA_Dal_Delivery_query($djax_delete_bkt_data);
}

function djax_feed_netword_stats($oStartDate, $oEndDate, $toTable)
{
    $query_network_stats = "INSERT INTO djax_feed_networks_stats
			(date_time,network_id,ad_id,zone_id,requests,impressions,clicks,conversions,revenue)
			SELECT date_time,network_id,ad_id,zone_id,requests,impressions,clicks,conversions,revenue
			FROM 
			(SELECT date_time,feed_network_id as network_id,ad_id,zone_id,sum( requests ) AS requests,sum( impressions) AS impressions,sum( clicks ) AS clicks,sum( conversions ) AS conversions,sum(revenue) as revenue
			FROM djax_feed_ad_bkt_stats
			WHERE 
			date_time >= '$oStartDate'
            AND date_time <= '$oEndDate'
			GROUP BY feed_network_id,date_time,ad_id,zone_id) AS virtual_table";
    $rows = OA_Dal_Delivery_query($query_network_stats);
}

function djax_feed_geo_stats($oStartDate, $oEndDate, $toTable)
{
    $query_geo_stats = "INSERT INTO djax_feed_networks_geo_stats
			(date_time,network_id,ad_id,zone_id,ip,country,state,city,longitude,lattitude,requests,impressions,clicks,conversions,revenue)
			SELECT date_time,network_id,ad_id,zone_id,ip,country,state,city,longitude,lattitude,requests,impressions,clicks,conversions,revenue
			FROM 
			(SELECT date_time,feed_network_id as network_id,ad_id,zone_id,ip as ip,country as country,state,city,lattitude,longitude,count( requests ) AS requests,
			sum( impressions) AS impressions,sum( clicks ) AS clicks,sum( conversions ) AS conversions,sum(revenue) as revenue
			FROM djax_feed_ad_bkt_stats
			WHERE 
			date_time >= '$oStartDate'
            AND date_time <= '$oEndDate'
			GROUP BY date_time,ad_id,zone_id,feed_network_id,ip,country,state,city,lattitude,longitude) AS virtual_table";
    $rows = OA_Dal_Delivery_query($query_geo_stats);
}

function djax_feed_client_stats($oStartDate, $oEndDate, $toTable)
{
    $query_client_stats = "INSERT INTO djax_feed_networks_client_stats
			(date_time,network_id,ad_id,zone_id,user_agent,requests,impressions,clicks,conversions,revenue)
			SELECT date_time,network_id,ad_id,zone_id,user_agent,requests,impressions,clicks,conversions,revenue
			FROM 
			(SELECT date_time,feed_network_id as network_id,ad_id,zone_id,user_agent as user_agent,count( requests ) AS requests,sum( impressions) AS impressions,sum( clicks ) AS clicks,sum( conversions ) AS conversions,sum(revenue) as revenue
			FROM djax_feed_ad_bkt_stats
			WHERE 
			date_time >='$oStartDate'
            AND date_time <='$oEndDate'
			GROUP BY date_time,feed_network_id,user_agent,ad_id,zone_id) AS virtual_table";
    $rows = OA_Dal_Delivery_query($query_client_stats);
}

function djax_feed_keyword_stats($oStartDate, $oEndDate, $toTable)
{
    $query_keyword_stats = "INSERT INTO djax_feed_networks_keyword_stats
			(date_time,network_id,ad_id,zone_id,keywords,requests,impressions,clicks,conversions,revenue)
			SELECT date_time,network_id,ad_id,zone_id,keywords,requests,impressions,clicks,conversions,revenue
			FROM 
			(SELECT date_time,feed_network_id as network_id,ad_id,zone_id,keyword as keywords,count( requests ) AS requests,
			sum( impressions) AS impressions,sum( clicks ) AS clicks,sum( conversions ) AS conversions,sum(revenue) as revenue
			FROM djax_feed_ad_bkt_stats
			WHERE 
			date_time >='$oStartDate'
            AND date_time <='$oEndDate'
			GROUP BY date_time,feed_network_id,keywords,ad_id,zone_id) AS virtual_table";
    $rows = OA_Dal_Delivery_query($query_keyword_stats);
}

?>
