<?php

// Require the initialisation file
require_once '../../../../init.php';

// Required files
require_once MAX_PATH . '/lib/OA/Admin/Option.php';
require_once MAX_PATH . '/lib/OA/Admin/Settings.php';

require_once MAX_PATH . '/lib/max/Plugin/Translation.php';
require_once MAX_PATH . '/www/admin/config.php';

if($GLOBALS['_MAX']['CONF']['database']['type']=='pgsql'){
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
}
else if($GLOBALS['_MAX']['CONF']['database']['type']=='mysqli'){
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
}

$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];

$admin_path =  $GLOBALS['_MAX']['CONF']['webpath']['admin'];

if ($GLOBALS['_MAX']['SSL_REQUEST']) 
{
	$djprotocol='https://';
}
else
{
	$djprotocol='http://';
}

OA_Permission::enforceAccount(OA_ACCOUNT_MANAGER);

OA_Permission::enforceAccessToObject('clients',   $clientid);
OA_Permission::enforceAccessToObject('campaigns', $campaignid);
OA_Permission::enforceAccessToObject('banners',   $bannerid);

$session['prefs']['inventory_entities'][OA_Permission::getEntityId()]['clientid'] = $clientid;
$session['prefs']['inventory_entities'][OA_Permission::getEntityId()]['campaignid'][$clientid] = $campaignid;
phpAds_SessionDataStore();

$pageName = basename($_SERVER['SCRIPT_NAME']);
$tabindex = 1;
$agencyId = OA_Permission::getAgencyId();
$aEntities = array('clientid' => $clientid, 'campaignid' => $campaignid, 'bannerid' => $bannerid);

// Display navigation
$aOtherCampaigns = Admin_DA::getPlacements(array('agency_id' => $agencyId));
$aOtherBanners = Admin_DA::getAds(array('placement_id' => $campaignid), false);
MAX_displayNavigationBanner($pageName, $aOtherCampaigns, $aOtherBanners, $aEntities);

if(isset($_POST['submitsettings']))
{
	if(!empty($_POST['keywordlist'])) 
	{
		$contextual = $_POST['keywordlist']; 
		OA_Dal_Delivery_query("delete from djax_feed_keyword where banner_id =".$bannerid." ") or die("error2");
		foreach($contextual as $key => $value) 
		{
			OA_Dal_Delivery_query("INSERT INTO djax_feed_keyword(banner_id,keyword) VALUES(".$bannerid.",".$value.")") or die("error1");
		}
	}
}

?>

<form action="" method="POST" enctype="multipart/form-data">
<table width="100%" cellspacing="0" cellpadding="0" border="0">
	<tbody>
		<tr>
			<td height="25" colspan="4">
				<b><h3>Targeting Property Settings</h3></b>
			</td>
		</tr>

		<tr>
			<td height="20" colspan="4"></td>
		</tr>
		<tr height="1">
			<td width="30" bgcolor="#888888"><img width="30" height="1" src=""></td>
			<td width="250" bgcolor="#888888"><img width="250" height="1" src=""></td>
			<td width="100%" bgcolor="#888888"><img width="1" height="1" src=""></td>
			<td width="30" bgcolor="#888888"><img width="30" height="1" src=""></td>
		</tr>


<?php

$resMeta = OA_Dal_Delivery_query("SELECT * FROM djax_feed_keywordlist") or die("error");

if (OA_Dal_Delivery_numRows($resMeta) > 0) {  
    $metaKeywords = [];
    $selectedKeywords = [];

    while ($rowMeta = OA_Dal_Delivery_fetchAssoc($resMeta)) {
        $metaKeywords[$rowMeta['keyword_id']] = $rowMeta['keyword'];
    }

    $banner_Id = $_GET['bannerid'];
    if ($banner_Id != '') {
       $resBannerKeyword = OA_Dal_Delivery_query("select * from djax_feed_keyword where banner_id = '".$banner_Id."'") or die("error");

					if (OA_Dal_Delivery_numRows($resBannerKeyword) >0)
					{
						while ($rowKeyword = OA_Dal_Delivery_fetchAssoc($resBannerKeyword))
							$selectedKeywords[$rowKeyword['keyword']] = $rowKeyword['keyword'];
					}
    }
    
    

    $i = 0;
    foreach ($metaKeywords as $key => $name) {
        $arrayName = "checkbox[" . $key . "]";
        $arrayRowName = "checkbox" . $key . "_" . $i;

        $isChecked = in_array($key, $selectedKeywords) ? 'checked' : '';

        ?>
        
        <tr>
            <td height="10" colspan="4"></td>
        </tr>
        <tr>
            <td>&nbsp;</td>
            <td width="100%" colspan="2" class="cellenabled">
                <input type="checkbox" tabindex="1" value="<?php echo $key; ?>" name="keywordlist[]" <?php echo $isChecked; ?>>
                <label><?php echo $name; ?></label>
            </td>
            <td>&nbsp;</td>
        </tr>
        <tr>
            <td height="10" colspan="4"></td>
        </tr>
        
        <?php

        $i++;
    }
}


?>

</tbody>
</table>
<br/>
<br/>
<input type="submit" tabindex="14" value="Save Changes" name="submitsettings">
</form>

<?php

phpAds_PageFooter();

?>

